=== debian/changelog ===
gringo (5.6.2-2) unstable; urgency=medium

  * Team upload
  * Acknowledge NMU, thanks Adrian!
  * Build without Python support, does not appear to be used anywhere
  * Drop patches reduce-thread-count.patch and
    skip-test_clingo_app.patch, no longer needed
  * Do not run gringo6 and gringo7 Python autopkgtests

 -- Graham Inggs <ginggs@debian.org>  Tue, 25 Jun 2024 11:40:12 +0000

gringo (5.6.2-1) unstable; urgency=medium

  * Team upload.

  [ Andreas Tille ]
  * New upstream version
  * Standards-Version: 4.6.2 (routine-update)
  * Reorder sequence of d/control fields by cme (routine-update)
  * Add ${python3:Depends}
  * Remove Python3 cache dir
  * Provide symbols file fo amd64 only (to prevent regression for
    #963054 and other potential issues)
  * Depends: python3
  * Fix versioned links to match SONAME
  * Build-Depends: dh-sequence-python3
  * Deactivate autopkgtests gringo1 and gringo4

  [ Matthias Klose ]
  * Fix build with Python 3.12. Closes: #1061316.
  * Fix build with new catch2 version. Closes: #1054688.
  * Fix build with GCC 13.
  * Explicitly mention the build system.

  [ Graham Inggs ]
  * Add (Build-)Depends: python3-cffi.
  * Reduce thread count for test_clingo_app.
  * Skip hanging test_clingo_app for now.

 -- Andreas Tille <tille@debian.org>  Mon, 12 Feb 2024 09:02:55 +0100

gringo (5.4.1-3.1) unstable; urgency=low

  * Non-maintainer upload.
  * Build using the default gcc. (Closes: #1023682)
  * Add patch from Lukas Märdian to use the system catch/catch2.
    (Closes: #1017161)
  * Fix the testsuite for Python no longer supporting 'rU' in open().
  * Remove the symbols file. (Closes: #963054, #1015422)

 -- Adrian Bunk <bunk@debian.org>  Sat, 19 Nov 2022 12:33:48 +0200
