=== debian/tests/control ===
Tests: gringo0, gringo1, gringo2, gringo3, gringo4, gringo5
Depends: @
